// src/common/data/rounding.ts
function isHalf(value) {
  return Math.abs(value) % 1 === 0.5;
}
function isEven(value) {
  return value % 2 === 0;
}
var roundUp = (value) => Math.ceil(value);
var roundDown = (value) => Math.floor(value);
var roundHalfUp = (value) => Math.round(value);
var roundHalfOdd = (value) => {
  const rounded = Math.round(value);
  if (!isHalf(value))
    return rounded;
  return isEven(rounded) ? rounded - 1 : rounded;
};
var roundHalfAwayFromZero = (value) => {
  return isHalf(value) ? Math.sign(value) * Math.ceil(Math.abs(value)) : Math.round(value);
};
var roundHalfDown = (value) => isHalf(value) ? Math.floor(value) : Math.round(value);
var roundHalfEven = (value) => {
  const rounded = Math.round(value);
  if (!isHalf(value))
    return rounded;
  return isEven(rounded) ? rounded : rounded - 1;
};
var roundHalfTowardsZero = (value) => isHalf(value) ? Math.sign(value) * Math.floor(Math.abs(value)) : Math.round(value);

export {
  isHalf,
  isEven,
  roundUp,
  roundDown,
  roundHalfUp,
  roundHalfOdd,
  roundHalfAwayFromZero,
  roundHalfDown,
  roundHalfEven,
  roundHalfTowardsZero
};
//# sourceMappingURL=chunk-AFUVZLZZ.js.map