import {
  size
} from "./chunk-R6KULE2F.js";

// src/common/data/is.ts
function isObject(obj) {
  return obj != null && typeof obj === "object";
}
function isPrimitive(obj) {
  return Object(obj) !== obj;
}
function isArray(obj) {
  return Array.isArray(obj);
}
function isRecord(obj) {
  return isObject(obj) && !isArray(obj);
}
function isRecordPlain(obj) {
  return obj?.constructor === Object;
}
function isString(obj) {
  return typeof obj === "string";
}
function isNumber(obj) {
  return typeof obj === "number" && !Number.isNaN(obj);
}
function isInteger(obj) {
  return isNumber(obj) && Number.isInteger(obj);
}
function isSafeInteger(obj) {
  return isNumber(obj) && Number.isSafeInteger(obj);
}
function isBoolean(obj) {
  return typeof obj === "boolean";
}
function isNullOrUndefined(obj) {
  return obj == null;
}
function isNull(obj) {
  return obj == null;
}
function isUint8Array(obj) {
  return isObject(obj) && obj.constructor.name === "Uint8Array";
}
function isNotNull(value) {
  return value != null;
}
function isEmpty(value) {
  return value == null || value === "" || isObject(value) && size(value) <= 0;
}
function isNotEmpty(value) {
  return !isEmpty(value);
}
function isValue(value) {
  return value != null && value !== false && value !== true;
}
function isTruthy(value) {
  return value != null && value !== false && value !== 0 && value !== "";
}

export {
  isObject,
  isPrimitive,
  isArray,
  isRecord,
  isRecordPlain,
  isString,
  isNumber,
  isInteger,
  isSafeInteger,
  isBoolean,
  isNullOrUndefined,
  isNull,
  isUint8Array,
  isNotNull,
  isEmpty,
  isNotEmpty,
  isValue,
  isTruthy
};
//# sourceMappingURL=chunk-EOHXRMVQ.js.map