import {
  getGlobalLoggerIfExists
} from "./chunk-VAS3X5GJ.js";

// src/common/assert.ts
function fatal(...messages) {
  getGlobalLoggerIfExists()?.("assert")?.fatal(...messages);
  throw new Error(`${messages.map(String).join(" ")}`);
}
function assert(condition, ...messages) {
  if (condition == null || typeof condition === "number" && Number.isNaN(condition) || !condition)
    fatal(...messages);
}
function assertCondition(condition, ...messages) {
  assert(condition, ...messages);
}

export {
  fatal,
  assert,
  assertCondition
};
//# sourceMappingURL=chunk-PXMCFDHI.js.map