"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }


var _chunk37DK2SKCcjs = require('./chunk-37DK2SKC.cjs');




var _chunkJSBFJVKMcjs = require('./chunk-JSBFJVKM.cjs');


var _chunkXO4K2T3Acjs = require('./chunk-XO4K2T3A.cjs');

// src/node/log/log-file.ts
var _fs = require('fs');
var _path = require('path');
var _process = require('process'); var _process2 = _interopRequireDefault(_process);
var namespaces = {};
function LoggerFileHandler(path, opt = {}) {
  const {
    level = void 0,
    filter = void 0,
    time = true,
    pretty = false
  } = opt;
  path = _path.resolve.call(void 0, _process2.default.cwd(), path);
  _fs.mkdirSync.call(void 0, _path.dirname.call(void 0, path), { recursive: true });
  const stream = _fs.createWriteStream.call(void 0, path, { flags: "a" });
  const matchesNamespace = _chunk37DK2SKCcjs.useNamespaceFilter.call(void 0, filter);
  const matchesLevel = _chunk37DK2SKCcjs.useLevelFilter.call(void 0, level);
  return (msg) => {
    if (!matchesLevel(msg.level))
      return;
    if (!matchesNamespace(msg.name))
      return;
    const timeNow = time ? `${(/* @__PURE__ */ new Date()).toISOString()} ` : "";
    const name = msg.name || "";
    const ninfo = namespaces[name || ""];
    if (ninfo == null)
      namespaces[name] = ninfo;
    const args = [
      `[${name || "*"}]`,
      _chunkXO4K2T3Acjs.renderMessages.call(void 0, msg.messages, { pretty })
    ];
    function write(...args2) {
      stream.write(`${args2.join("	")}
`);
    }
    switch (msg.level) {
      case _chunkJSBFJVKMcjs.LogLevelInfo:
        write(`${timeNow}I|*  `, ...args);
        break;
      case _chunkJSBFJVKMcjs.LogLevelWarn:
        write(`${timeNow}W|** `, ...args);
        break;
      case _chunkJSBFJVKMcjs.LogLevelError:
        write(`${timeNow}E|***`, ...args);
        break;
      default:
        write(`${timeNow}D|   `, ...args);
        break;
    }
  };
}



exports.LoggerFileHandler = LoggerFileHandler;
//# sourceMappingURL=chunk-RXYB6EWZ.cjs.map