"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } } function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }

var _chunkQYCE2TUJcjs = require('./chunk-QYCE2TUJ.cjs');

// src/common/msg/rpc.ts
var rpcCounter = 1;
var defaultSerialize = (i) => i;
var defaultDeserialize = defaultSerialize;
function setupRPCBasic(options, functions, eventNames = []) {
  const {
    log,
    post,
    on,
    serialize = defaultSerialize,
    deserialize = defaultDeserialize,
    timeout = 6e4,
    onError,
    onTimeoutError,
    onlyEvents = false
  } = options;
  const rpcPromiseMap = /* @__PURE__ */ new Map();
  on(async (data) => {
    try {
      const msg = await deserialize(data);
      const mode = _optionalChain([msg, 'optionalAccess', _2 => _2[0]]);
      const id = mode === 2 /* event */ ? 0 : _optionalChain([msg, 'optionalAccess', _3 => _3[1]]);
      const [method, ...args] = msg.slice(mode === 2 /* event */ ? 1 : 2);
      if (mode === 1 /* request */ || mode === 2 /* event */) {
        let result, error;
        if (method != null) {
          try {
            const fn = functions[method];
            result = await fn(...args);
          } catch (e) {
            error = String(e);
          }
        } else {
          error = "Method implementation missing";
        }
        if (error) {
          _optionalChain([log, 'optionalAccess', _4 => _4.warn, 'call', _5 => _5("error", msg, error)]);
          _optionalChain([onError, 'optionalCall', _6 => _6(error, _nullishCoalesce(method, () => ( "")), args)]);
        }
        if (id > 0) {
          const data2 = await serialize(error ? [4 /* reject */, id, error] : [3 /* resolve */, id, result]);
          await post(data2);
        }
      } else if (id) {
        const promise = rpcPromiseMap.get(id);
        if (promise != null) {
          clearTimeout(promise.timeoutId);
          if (mode === 4 /* reject */)
            promise.reject(method);
          else
            promise.resolve(method);
        }
        rpcPromiseMap.delete(id);
      }
    } catch (err) {
      _optionalChain([log, 'optionalAccess', _7 => _7.warn, 'call', _8 => _8("Error on handling RPC data. Invalid?", err, data)]);
    }
  });
  const proxyHandler = {
    get(_, method) {
      const sendEvent = async (...args) => await post(await serialize([2 /* event */, method, ...args]));
      if (onlyEvents || eventNames.includes(method)) {
        sendEvent.asEvent = sendEvent;
        return sendEvent;
      }
      const sendCall = async (...args) => {
        const [promise, resolve, reject] = _chunkQYCE2TUJcjs.createPromise.call(void 0, );
        const id = rpcCounter++;
        let timeoutId;
        if (timeout >= 0) {
          timeoutId = _optionalChain([setTimeout, 'call', _9 => _9(() => {
            try {
              _optionalChain([onTimeoutError, 'optionalCall', _10 => _10(method, args)]);
              throw new Error(`rpc timeout on calling "${method}"`);
            } catch (e) {
              reject(e);
            }
            rpcPromiseMap.delete(id);
          }, timeout), 'access', _11 => _11.unref, 'optionalCall', _12 => _12()]);
        }
        rpcPromiseMap.set(id, { resolve, reject, timeoutId });
        const data = await serialize([1 /* request */, id, method, ...args]);
        await post(data);
        return promise;
      };
      sendCall.asEvent = sendEvent;
      return sendCall;
    }
  };
  return { post, serialize, rpcPromiseMap, proxyHandler };
}
function useRPC(functions, options) {
  const { eventNames = [] } = options;
  const { proxyHandler } = setupRPCBasic(options, functions, eventNames);
  return new Proxy({}, proxyHandler);
}
function useRPCHub(options) {
  const eventNames = [];
  const functions = {};
  const { proxyHandler } = setupRPCBasic(options, functions);
  function createRPCProxy() {
    return new Proxy({}, proxyHandler);
  }
  return function(additionalFunctions, additionalEventNames = []) {
    Object.assign(functions, _nullishCoalesce(additionalFunctions, () => ( {})));
    eventNames.push(...additionalEventNames);
    return createRPCProxy();
  };
}




exports.useRPC = useRPC; exports.useRPCHub = useRPCHub;
//# sourceMappingURL=chunk-SDJIWERF.cjs.map