"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } }



var _chunkPOMZSIODcjs = require('./chunk-POMZSIOD.cjs');

// src/common/data/object.ts
function objectMap(obj, fn) {
  if (!_chunkPOMZSIODcjs.isObject.call(void 0, obj))
    return {};
  return Object.fromEntries(
    Object.entries(obj).map(([k, v]) => {
      const r = fn(k, v);
      if (_chunkPOMZSIODcjs.isArray.call(void 0, r) && r.length === 2)
        return r;
      return [k, r];
    }).filter((v) => v != null)
  );
}
function objectMergeDisposable(a, b) {
  if (b.dispose && a.dispose) {
    b.dispose.add(a.dispose);
  }
  return Object.assign(a, b);
}
function objectIsEmpty(obj) {
  return Object.keys(obj).length <= 0;
}
function objectPick(obj, ...keys) {
  return Object.fromEntries(keys.filter((key) => key in obj).map((key) => [key, obj[key]]));
}
function objectInclusivePick(obj, ...keys) {
  return Object.fromEntries(keys.map((key) => [key, obj[key]]));
}
function objectOmit(obj, ...keys) {
  return Object.fromEntries(Object.entries(obj).filter(([key]) => !keys.includes(key)));
}
function objectPlain(obj, opt) {
  const {
    maxDepth = 99,
    circleValue,
    maxDepthValue,
    removeEmptyArray = false,
    removeEmptyString = false,
    removeNull = false,
    removeUndefined = false
  } = _nullishCoalesce(opt, () => ( {}));
  const cycle = [];
  function keepValue(value) {
    if (removeUndefined && value === void 0)
      return false;
    if (removeNull && value === null)
      return false;
    if (removeEmptyString && value === "")
      return false;
    if (removeEmptyArray && _chunkPOMZSIODcjs.isArray.call(void 0, value) && value.length <= 0)
      return false;
    return true;
  }
  function handleObject(obj2, depth) {
    if (depth > maxDepth)
      return maxDepthValue;
    if (_chunkPOMZSIODcjs.isPrimitive.call(void 0, obj2))
      return obj2;
    if (cycle.includes(obj2))
      return circleValue;
    cycle.push(obj2);
    if (Array.isArray(obj2))
      return obj2.map((o) => handleObject(o, depth + 1)).filter(keepValue);
    if (_chunkPOMZSIODcjs.isObject.call(void 0, obj2)) {
      const nobj = {};
      for (const [key, value] of Object.entries(obj2)) {
        if (keepValue(value))
          nobj[key] = handleObject(value, depth + 1);
      }
      return nobj;
    }
    return void 0;
  }
  return handleObject(obj, 0);
}









exports.objectMap = objectMap; exports.objectMergeDisposable = objectMergeDisposable; exports.objectIsEmpty = objectIsEmpty; exports.objectPick = objectPick; exports.objectInclusivePick = objectInclusivePick; exports.objectOmit = objectOmit; exports.objectPlain = objectPlain;
//# sourceMappingURL=chunk-UYIEHLQK.cjs.map