/**
 * Original at https://github.com/dmonad/lib0
 *
 * Utility module to work with strings.
 */
declare function trimLeft(s: string): string;
declare function fromCamelCase(s: string, separator: string): string;
/**
 * Compute the utf8ByteLength
 */
declare function utf8ByteLength(str: string): number;
declare function _encodeUtf8Polyfill(str: string): Uint8Array;
declare function getUtf8TextEncoder(): TextEncoder | null;
declare function encodeUtf8(str: string): Uint8Array;
declare function getUtf8TextDecoder(): TextDecoder | undefined;
declare function decodeUtf8(buf: Uint8Array): string;
declare function splice(str: string, index: number, remove: number, insert?: string): string;

export { _encodeUtf8Polyfill, decodeUtf8, encodeUtf8, fromCamelCase, getUtf8TextDecoder, getUtf8TextEncoder, splice, trimLeft, utf8ByteLength };
