"use strict"; function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }



var _chunkUXNJ5WZMcjs = require('../../chunk-UXNJ5WZM.cjs');
require('../../chunk-QYCE2TUJ.cjs');











var _chunkANZPWIO4cjs = require('../../chunk-ANZPWIO4.cjs');

// src/common/data/day.spec.ts
describe("days", () => {
  it("day Simple Approach", () => {
    const date = /* @__PURE__ */ new Date("1987-12-31T00:02:03");
    const simpleDateInteger = date.getFullYear() * 1e4 + (date.getMonth() + 1) * 100 + date.getDate();
    expect(simpleDateInteger).toBe(19871231);
    const fromSimpleDateInteger = new Date(
      simpleDateInteger / 1e4,
      // year
      simpleDateInteger / 100 % 100 - 1,
      // month
      simpleDateInteger % 100
      // day
    );
    expect(fromSimpleDateInteger.toDateString()).toEqual(date.toDateString());
  });
  it("day Continuous Approach", () => {
    const date = /* @__PURE__ */ new Date("1987-12-31T00:01:02");
    const DAY_IN_MILLISECONDS = 86400 * 1e3;
    const timeZoneInMilliSeconds = date.getTimezoneOffset() * 60 * 1e3;
    const continuousDateInteger = Math.floor(
      (date.getTime() - timeZoneInMilliSeconds) / DAY_IN_MILLISECONDS
    );
    expect(continuousDateInteger).toBe(6573);
    const fromContinuousDateInteger = new Date(
      continuousDateInteger * DAY_IN_MILLISECONDS + timeZoneInMilliSeconds
    );
    expect(fromContinuousDateInteger.toDateString()).toEqual(
      date.toDateString()
    );
  });
  it("should iterate days", () => {
    const list = [];
    void _chunkUXNJ5WZMcjs.forEachDay.call(void 0, 20101230, 20110102, (x) => list.push(x.toString()));
    expect(list).toEqual([
      "2010-12-30",
      "2010-12-31",
      "2011-01-01",
      "2011-01-02"
    ]);
    const list2 = [];
    void _chunkUXNJ5WZMcjs.forEachDay.call(void 0, 19991030, 19991102, (x) => list2.push(x.toString()));
    expect(list2).toEqual([
      "1999-10-30",
      "1999-10-31",
      "1999-11-01",
      "1999-11-02"
    ]);
  });
  it("should use Day class", () => {
    {
      const day = _chunkUXNJ5WZMcjs.Day.from(/* @__PURE__ */ new Date("1987-12-31T00:02:03"));
      expect(_optionalChain([day, 'optionalAccess', _ => _.days])).toEqual(19871231);
      expect(_optionalChain([day, 'optionalAccess', _2 => _2.dayOffset, 'call', _3 => _3(1), 'access', _4 => _4.days])).toEqual(19880101);
      expect(_optionalChain([day, 'optionalAccess', _5 => _5.dayOffset, 'call', _6 => _6(-1), 'access', _7 => _7.days])).toEqual(19871230);
      expect(_optionalChain([day, 'optionalAccess', _8 => _8.toString, 'call', _9 => _9()])).toEqual("1987-12-31");
      expect(_optionalChain([day, 'optionalAccess', _10 => _10.toString, 'call', _11 => _11("")])).toEqual("19871231");
      expect(_optionalChain([day, 'optionalAccess', _12 => _12.toDateGMT, 'call', _13 => _13()])).toEqual(/* @__PURE__ */ new Date("1987-12-31T00:00:00.000Z"));
      expect(_optionalChain([_chunkUXNJ5WZMcjs.Day, 'access', _14 => _14.fromString, 'call', _15 => _15("2000-01-01"), 'optionalAccess', _16 => _16.days])).toEqual(20000101);
      expect(_optionalChain([_chunkUXNJ5WZMcjs.Day, 'access', _17 => _17.fromString, 'call', _18 => _18("2000-01-01"), 'optionalAccess', _19 => _19.daysUntil, 'call', _20 => _20(19871231)])).toBe(-4384);
      expect(_optionalChain([_chunkUXNJ5WZMcjs.Day, 'access', _21 => _21.fromString, 'call', _22 => _22("2000-01-01"), 'optionalAccess', _23 => _23.daysUntil, 'call', _24 => _24("2000-01-31")])).toBe(30);
      expect(_optionalChain([_chunkUXNJ5WZMcjs.Day, 'access', _25 => _25.fromString, 'call', _26 => _26("2021-01-01"), 'optionalAccess', _27 => _27.daysUntil, 'call', _28 => _28("2021-03-01")])).toBe(59);
      expect(_optionalChain([_chunkUXNJ5WZMcjs.Day, 'access', _29 => _29.fromString, 'call', _30 => _30("2020-01-01"), 'optionalAccess', _31 => _31.daysUntil, 'call', _32 => _32("2020-03-01")])).toBe(60);
      expect(_optionalChain([_chunkUXNJ5WZMcjs.Day, 'access', _33 => _33.from, 'call', _34 => _34([2022, 12, 31]), 'optionalAccess', _35 => _35.days])).toBe(20221231);
    }
    {
      const day = _chunkANZPWIO4cjs.dayFromDate.call(void 0, /* @__PURE__ */ new Date("1987-12-31T00:02:03"));
      expect(day).toEqual(19871231);
      expect(_chunkANZPWIO4cjs.dayOffset.call(void 0, day, 1)).toEqual(19880101);
      expect(_chunkANZPWIO4cjs.dayOffset.call(void 0, day, -1)).toEqual(19871230);
      expect(_chunkANZPWIO4cjs.dayToString.call(void 0, day)).toEqual("1987-12-31");
      expect(_chunkANZPWIO4cjs.dayToString.call(void 0, day, "")).toEqual("19871231");
      expect(_chunkANZPWIO4cjs.dayDiff.call(void 0, 20000101, 19871231)).toBe(-4384);
      expect(_chunkANZPWIO4cjs.dayDiff.call(void 0, 20000101, 20000131)).toBe(30);
      expect(_chunkANZPWIO4cjs.dayDiff.call(void 0, 20210101, 20210301)).toBe(59);
      expect(_chunkANZPWIO4cjs.dayDiff.call(void 0, 20200101, 20200301)).toBe(60);
    }
  });
  it("should properties", () => {
    const d = _chunkUXNJ5WZMcjs.Day.fromString("2021-12-31");
    expect(d.days).toEqual(20211231);
    expect(d.day).toEqual(31);
    expect(d.month).toEqual(12);
    expect(d.year).toEqual(2021);
  });
  it("should calc months", () => {
    {
      const d = _chunkUXNJ5WZMcjs.Day.fromString("2021-12-01");
      expect(_optionalChain([d, 'access', _36 => _36.monthOffset, 'call', _37 => _37(0), 'optionalAccess', _38 => _38.days])).toBe(20211201);
      expect(_optionalChain([d, 'access', _39 => _39.monthOffset, 'call', _40 => _40(1), 'optionalAccess', _41 => _41.days])).toBe(20220101);
      expect(_optionalChain([d, 'access', _42 => _42.monthOffset, 'call', _43 => _43(2), 'optionalAccess', _44 => _44.days])).toBe(20220201);
      expect(_optionalChain([d, 'access', _45 => _45.monthOffset, 'call', _46 => _46(11), 'optionalAccess', _47 => _47.days])).toBe(20221101);
      expect(_optionalChain([d, 'access', _48 => _48.monthOffset, 'call', _49 => _49(24), 'optionalAccess', _50 => _50.days])).toBe(20231201);
      expect(_optionalChain([d, 'access', _51 => _51.monthOffset, 'call', _52 => _52(-1), 'optionalAccess', _53 => _53.days])).toBe(20211101);
      expect(_optionalChain([d, 'access', _54 => _54.monthOffset, 'call', _55 => _55(-2), 'optionalAccess', _56 => _56.days])).toBe(20211001);
      expect(_optionalChain([d, 'access', _57 => _57.monthOffset, 'call', _58 => _58(-11), 'optionalAccess', _59 => _59.days])).toBe(20210101);
      expect(_optionalChain([d, 'access', _60 => _60.monthOffset, 'call', _61 => _61(-24), 'optionalAccess', _62 => _62.days])).toBe(20191201);
    }
    {
      const d = _chunkANZPWIO4cjs.dayFromString.call(void 0, "1999-12-31");
      expect(d).toMatchInlineSnapshot("19991231");
      expect(_chunkANZPWIO4cjs.dayToParts.call(void 0, d)).toMatchInlineSnapshot(`
        Array [
          1999,
          12,
          31,
        ]
      `);
      expect(_chunkANZPWIO4cjs.dayMonthStart.call(void 0, d)).toMatchInlineSnapshot("19991201");
      expect(_chunkANZPWIO4cjs.dayMonthStart.call(void 0, d, 1)).toMatchInlineSnapshot("20000101");
      expect(_chunkANZPWIO4cjs.dayMonthStart.call(void 0, d, 2)).toMatchInlineSnapshot("20000201");
      expect(_chunkANZPWIO4cjs.dayMonthStart.call(void 0, d, 11)).toMatchInlineSnapshot("20001101");
      expect(_chunkANZPWIO4cjs.dayMonthStart.call(void 0, d, 12)).toMatchInlineSnapshot("20001201");
      expect(_chunkANZPWIO4cjs.dayMonthStart.call(void 0, d, 24)).toMatchInlineSnapshot("20011201");
      expect(_chunkANZPWIO4cjs.dayMonthStart.call(void 0, d, -1)).toMatchInlineSnapshot("19991101");
      expect(_chunkANZPWIO4cjs.dayMonthStart.call(void 0, d, -2)).toMatchInlineSnapshot("19991001");
      expect(_chunkANZPWIO4cjs.dayMonthStart.call(void 0, d, -11)).toMatchInlineSnapshot("19990101");
      expect(_chunkANZPWIO4cjs.dayMonthStart.call(void 0, d, -24)).toMatchInlineSnapshot("19971201");
      expect(_chunkANZPWIO4cjs.dayYearStart.call(void 0, d)).toMatchInlineSnapshot("19990101");
      expect(_chunkANZPWIO4cjs.dayYearStart.call(void 0, d, -10)).toMatchInlineSnapshot("19890101");
      expect(_chunkANZPWIO4cjs.dayYearStart.call(void 0, d, 10)).toMatchInlineSnapshot("20090101");
    }
  });
  it("should parse date string", () => {
    expect((/* @__PURE__ */ new Date("2019-08-05T13:14:31.000Z")).toISOString()).toEqual(
      "2019-08-05T13:14:31.000Z"
    );
    expect(_chunkUXNJ5WZMcjs.dateStringToDays.call(void 0, "2019-08-05T13:14:31.000Z")).toBe(20190805);
  });
  it("should start", () => {
    const d = _chunkUXNJ5WZMcjs.Day.fromString("2021-12-31");
    expect(d.yearStart().days).toBe(20210101);
    expect(d.monthStart().days).toBe(20211201);
  });
  it("should dayFromString", () => {
    expect(_chunkANZPWIO4cjs.dayFromString.call(void 0, "20121030")).toEqual(20121030);
    expect(_chunkANZPWIO4cjs.dayFromString.call(void 0, "2012-10-30T12:00:00Z")).toEqual(20121030);
    expect(_chunkANZPWIO4cjs.dayFromString.call(void 0, "fasfasdf sadf ")).toEqual(void 0);
  });
  it("should dayRange", () => {
    expect(_chunkANZPWIO4cjs.dayRange.call(void 0, 20121230, 20130104)).toMatchInlineSnapshot(`
      Array [
        20121230,
        20121231,
        20130101,
        20130102,
        20130103,
        20130104,
      ]
    `);
    expect(_chunkANZPWIO4cjs.dayRange.call(void 0, -6, 20130104)).toMatchInlineSnapshot(`
      Array [
        20121230,
        20121231,
        20130101,
        20130102,
        20130103,
        20130104,
      ]
    `);
    expect(_chunkANZPWIO4cjs.dayIterator.call(void 0, -6, 20130104).next().value).toEqual(20121230);
  });
});
//# sourceMappingURL=day.spec.cjs.map