"use strict";




var _chunkZGKV237Zcjs = require('../../chunk-ZGKV237Z.cjs');

// src/common/data/list.spec.ts
var sampleList = [
  { id: 1, title: "aaa", age: 22 },
  { id: 2, title: "bbb", age: 22 },
  { id: 3, title: "agga", age: 33 }
];
describe("list", () => {
  it("should query", () => {
    expect(_chunkZGKV237Zcjs.listOfKey.call(void 0, sampleList, "age")).toMatchInlineSnapshot(`
      Array [
        22,
        22,
        33,
      ]
    `);
    expect(_chunkZGKV237Zcjs.listDistinctUnion.call(void 0, sampleList, "age")).toMatchInlineSnapshot(`
      Array [
        22,
        33,
      ]
    `);
    expect(_chunkZGKV237Zcjs.listGroupBy.call(void 0, sampleList, "age")).toMatchInlineSnapshot(`
      Object {
        "22": Array [
          Object {
            "age": 22,
            "id": 1,
            "title": "aaa",
          },
          Object {
            "age": 22,
            "id": 2,
            "title": "bbb",
          },
        ],
        "33": Array [
          Object {
            "age": 33,
            "id": 3,
            "title": "agga",
          },
        ],
      }
    `);
    expect(
      _chunkZGKV237Zcjs.listQuery.call(void 0, 
        sampleList,
        [(e) => e.title.startsWith("a"), (e) => e.id <= 2],
        [(e) => e.age += 1]
      )
    ).toMatchInlineSnapshot(`
      Array [
        23,
      ]
    `);
  });
});
//# sourceMappingURL=list.spec.cjs.map