"use strict";



var _chunk3NP7UZMUcjs = require('../chunk-3NP7UZMU.cjs');
require('../chunk-NU2LARFE.cjs');
require('../chunk-QLGR2XSS.cjs');
require('../chunk-ORVIR4M4.cjs');
require('../chunk-NK2RDF67.cjs');
require('../chunk-BXH2HPYJ.cjs');
require('../chunk-OHEPH4HC.cjs');
require('../chunk-SDJIWERF.cjs');
require('../chunk-Q4UVDWYW.cjs');
require('../chunk-62FVEJL6.cjs');
require('../chunk-IPYKH5TA.cjs');
require('../chunk-TOO6MUER.cjs');
require('../chunk-QZHRO76T.cjs');
require('../chunk-EVXYYIX7.cjs');
require('../chunk-YMHH3L5N.cjs');
require('../chunk-O3QYDQEH.cjs');
require('../chunk-XG57S66T.cjs');
require('../chunk-CYJAPNWA.cjs');
require('../chunk-JSDQUV2F.cjs');
require('../chunk-RJM35BFG.cjs');
require('../chunk-BKBCRA55.cjs');
require('../chunk-ZYPCVNSG.cjs');
require('../chunk-BBX7CCGY.cjs');
require('../chunk-N46W55MH.cjs');
require('../chunk-37DK2SKC.cjs');
require('../chunk-JSBFJVKM.cjs');
require('../chunk-NYVRXH32.cjs');
require('../chunk-CXBBK7CI.cjs');
require('../chunk-R7WMTFSS.cjs');
require('../chunk-DRTH56G4.cjs');
require('../chunk-XWE2OTGL.cjs');
require('../chunk-KTC5RW57.cjs');
require('../chunk-A4VFMLAN.cjs');
require('../chunk-7XAMJGPO.cjs');
require('../chunk-RKOTNV3K.cjs');
require('../chunk-ZGKV237Z.cjs');
require('../chunk-UYIEHLQK.cjs');
require('../chunk-N7OUNPMM.cjs');
require('../chunk-MPD2DJAD.cjs');
require('../chunk-YELWQAMG.cjs');
require('../chunk-AZ5FKZIK.cjs');
require('../chunk-POMZSIOD.cjs');
require('../chunk-FEYF6QXS.cjs');
require('../chunk-XO4K2T3A.cjs');
require('../chunk-3SM3C7HY.cjs');
require('../chunk-UXNJ5WZM.cjs');
require('../chunk-QYCE2TUJ.cjs');
require('../chunk-ANZPWIO4.cjs');
require('../chunk-CEXYDYSH.cjs');
require('../chunk-PJXRDQ2A.cjs');
require('../chunk-6T6PI6XG.cjs');
require('../chunk-XDY4SRCL.cjs');
require('../chunk-FYLSPYV2.cjs');
require('../chunk-YKRFYR2Q.cjs');
require('../chunk-QU2LM4AI.cjs');
require('../chunk-BMRI2X66.cjs');
require('../chunk-66YRDFQP.cjs');
require('../chunk-7FPSHSSO.cjs');

// src/common/dispose-utils.spec.ts
var _vitest = require('vitest');
describe("useTimeout", () => {
  it("should call the provided function after the specified timeout", () => {
    _vitest.vi.useFakeTimers();
    const mockFn = _vitest.vi.fn();
    const timeout = 1e3;
    _chunk3NP7UZMUcjs.useTimeout.call(void 0, mockFn, timeout);
    expect(mockFn).not.toBeCalled();
    _vitest.vi.advanceTimersByTime(timeout);
    expect(mockFn).toBeCalled();
  });
  it("should cancel the timeout when the disposer function is called", () => {
    _vitest.vi.useFakeTimers();
    const mockFn = _vitest.vi.fn();
    const timeout = 1e3;
    const disposer = _chunk3NP7UZMUcjs.useTimeout.call(void 0, mockFn, timeout);
    expect(mockFn).not.toBeCalled();
    disposer();
    _vitest.vi.advanceTimersByTime(timeout);
    expect(mockFn).not.toBeCalled();
  });
  it('should add event listener using "on" method if available', () => {
    const emitter = {
      on: _vitest.vi.fn(),
      off: _vitest.vi.fn()
    };
    const eventName = "click";
    const fn = _vitest.vi.fn();
    const args = [1, 2, 3];
    const disposer = _chunk3NP7UZMUcjs.useEventListener.call(void 0, emitter, eventName, fn, ...args);
    expect(emitter.on).toBeCalledWith(eventName, fn, ...args);
    expect(emitter.off).not.toBeCalled();
    disposer();
    expect(emitter.off).toBeCalledWith(eventName, fn, ...args);
  });
  it('should add event listener using "addEventListener" method if "on" method is not available', () => {
    const emitter = {
      addEventListener: _vitest.vi.fn(),
      removeEventListener: _vitest.vi.fn()
    };
    const eventName = "click";
    const fn = _vitest.vi.fn();
    const args = [1, 2, 3];
    const disposer = _chunk3NP7UZMUcjs.useEventListener.call(void 0, emitter, eventName, fn, ...args);
    expect(emitter.addEventListener).toBeCalledWith(eventName, fn, ...args);
    expect(emitter.removeEventListener).not.toBeCalled();
    disposer();
    expect(emitter.removeEventListener).toBeCalledWith(eventName, fn, ...args);
  });
  it("should return an empty disposer function if emitter is null", () => {
    const emitter = null;
    const eventName = "click";
    const fn = _vitest.vi.fn();
    const args = [1, 2, 3];
    const disposer = _chunk3NP7UZMUcjs.useEventListener.call(void 0, emitter, eventName, fn, ...args);
    expect(disposer).toEqual(expect.any(Function));
    disposer();
  });
  it("should add timeout disposer to the dispose object", () => {
    _vitest.vi.useFakeTimers();
    const mockFn = _vitest.vi.fn();
    const timeout = 1e3;
    const dispose = _chunk3NP7UZMUcjs.useDisposeWithUtils.call(void 0, );
    dispose.timeout(mockFn, timeout);
    expect(mockFn).not.toBeCalled();
    _vitest.vi.advanceTimersByTime(timeout);
    expect(mockFn).toBeCalled();
  });
  it("should add interval disposer to the dispose object", () => {
    _vitest.vi.useFakeTimers();
    const mockFn = _vitest.vi.fn();
    const interval = 1e3;
    const dispose = _chunk3NP7UZMUcjs.useDisposeWithUtils.call(void 0, );
    dispose.interval(mockFn, interval);
    expect(mockFn).not.toBeCalled();
    _vitest.vi.advanceTimersByTime(interval);
    expect(mockFn).toBeCalled();
  });
  it('should add event listener disposer to the dispose object using "on" method', async () => {
    const emitter = {
      on: _vitest.vi.fn(),
      off: _vitest.vi.fn()
    };
    const eventName = "click";
    const fn = _vitest.vi.fn();
    const args = [1, 2, 3];
    const dispose = _chunk3NP7UZMUcjs.useDisposeWithUtils.call(void 0, );
    dispose.on(emitter, eventName, fn, ...args);
    expect(emitter.on).toBeCalledWith(eventName, fn, ...args);
    expect(emitter.off).not.toBeCalled();
    await dispose.dispose();
    expect(emitter.off).toBeCalledWith(eventName, fn, ...args);
  });
  it('should add event listener disposer to the dispose object using "addEventListener" method', async () => {
    const emitter = {
      addEventListener: _vitest.vi.fn(),
      removeEventListener: _vitest.vi.fn()
    };
    const eventName = "click";
    const fn = _vitest.vi.fn();
    const args = [1, 2, 3];
    const dispose = _chunk3NP7UZMUcjs.useDisposeWithUtils.call(void 0, );
    dispose.on(emitter, eventName, fn, ...args);
    expect(emitter.addEventListener).toBeCalledWith(eventName, fn, ...args);
    expect(emitter.removeEventListener).not.toBeCalled();
    await dispose.dispose();
    expect(emitter.removeEventListener).toBeCalledWith(eventName, fn, ...args);
  });
  it("should return an empty disposer function if emitter is null 2", () => {
    const emitter = null;
    const eventName = "click";
    const fn = _vitest.vi.fn();
    const args = [1, 2, 3];
    const dispose = _chunk3NP7UZMUcjs.useDisposeWithUtils.call(void 0, );
    const disposer = dispose.on(emitter, eventName, fn, ...args);
    expect(disposer).toEqual(expect.any(Function));
    disposer();
  });
});
//# sourceMappingURL=dispose-utils.spec.cjs.map