"use strict";


var _chunkDF4AIGIWcjs = require('../../chunk-DF4AIGIW.cjs');
require('../../chunk-JCNZZG5S.cjs');
require('../../chunk-5FE5DCG4.cjs');
require('../../chunk-SFUIGVPA.cjs');
require('../../chunk-X23ZSPZC.cjs');
require('../../chunk-2UTQQDPY.cjs');
require('../../chunk-CR4EGXJY.cjs');



var _chunkSDJIWERFcjs = require('../../chunk-SDJIWERF.cjs');


var _chunkIPYKH5TAcjs = require('../../chunk-IPYKH5TA.cjs');
require('../../chunk-EVXYYIX7.cjs');
require('../../chunk-YMHH3L5N.cjs');
require('../../chunk-O3QYDQEH.cjs');
require('../../chunk-XG57S66T.cjs');
require('../../chunk-CYJAPNWA.cjs');
require('../../chunk-JSDQUV2F.cjs');
require('../../chunk-RJM35BFG.cjs');
require('../../chunk-BKBCRA55.cjs');
require('../../chunk-ZYPCVNSG.cjs');
require('../../chunk-BBX7CCGY.cjs');
require('../../chunk-N46W55MH.cjs');
require('../../chunk-37DK2SKC.cjs');
require('../../chunk-JSBFJVKM.cjs');
require('../../chunk-NYVRXH32.cjs');
require('../../chunk-CXBBK7CI.cjs');
require('../../chunk-R7WMTFSS.cjs');
require('../../chunk-DRTH56G4.cjs');
require('../../chunk-XWE2OTGL.cjs');
require('../../chunk-KTC5RW57.cjs');
require('../../chunk-A4VFMLAN.cjs');
require('../../chunk-7XAMJGPO.cjs');
require('../../chunk-RKOTNV3K.cjs');
require('../../chunk-ZGKV237Z.cjs');
require('../../chunk-UYIEHLQK.cjs');
require('../../chunk-N7OUNPMM.cjs');
require('../../chunk-MPD2DJAD.cjs');
require('../../chunk-YELWQAMG.cjs');
require('../../chunk-AZ5FKZIK.cjs');
require('../../chunk-POMZSIOD.cjs');
require('../../chunk-FEYF6QXS.cjs');
require('../../chunk-XO4K2T3A.cjs');
require('../../chunk-3SM3C7HY.cjs');
require('../../chunk-UXNJ5WZM.cjs');


var _chunkQYCE2TUJcjs = require('../../chunk-QYCE2TUJ.cjs');
require('../../chunk-ANZPWIO4.cjs');
require('../../chunk-CEXYDYSH.cjs');
require('../../chunk-PJXRDQ2A.cjs');
require('../../chunk-6T6PI6XG.cjs');
require('../../chunk-XDY4SRCL.cjs');
require('../../chunk-FYLSPYV2.cjs');
require('../../chunk-YKRFYR2Q.cjs');
require('../../chunk-QU2LM4AI.cjs');
require('../../chunk-BMRI2X66.cjs');
require('../../chunk-66YRDFQP.cjs');
require('../../chunk-7FPSHSSO.cjs');

// src/common/msg/rpc.spec.ts
var _worker_threads = require('worker_threads');
var bobCount = 0;
var Bob = {
  hi(name) {
    return `Hi ${name}, I am Bob`;
  },
  bump() {
    bobCount += 1;
  },
  getCount() {
    return bobCount;
  }
};
var Alice = {
  hello(name) {
    return `Hello ${name}, my name is Alice`;
  }
};
describe("rpc async", () => {
  beforeEach(() => {
    bobCount = 0;
  });
  it("basic", async () => {
    const channel = new (0, _worker_threads.MessageChannel)();
    const serialize = (data) => _chunkDF4AIGIWcjs.encodeJson.call(void 0, data);
    const deserialize = (data) => _chunkDF4AIGIWcjs.decodeJson.call(void 0, data);
    const bob = _chunkSDJIWERFcjs.useRPC.call(void 0, Bob, {
      post: (data) => channel.port1.postMessage(data),
      on: (data) => channel.port1.on("message", data),
      serialize,
      deserialize
    });
    const alice = _chunkSDJIWERFcjs.useRPC.call(void 0, Alice, {
      // mark bob's `bump` as an event without response
      eventNames: ["bump"],
      post: (data) => channel.port2.postMessage(data),
      on: (data) => channel.port2.on("message", data),
      serialize,
      deserialize
    });
    expect(await bob.hello("Bob")).toEqual("Hello Bob, my name is Alice");
    expect(await alice.hi("Alice")).toEqual("Hi Alice, I am Bob");
    expect(void alice.bump()).toBeUndefined();
    expect(Bob.getCount()).toBe(0);
    await new Promise((resolve) => setTimeout(resolve, 100));
    expect(Bob.getCount()).toBe(1);
    channel.port1.close();
    channel.port2.close();
  });
  it("hub", async () => {
    const channel = new (0, _worker_threads.MessageChannel)();
    const serialize = (data) => _chunkDF4AIGIWcjs.encodeJson.call(void 0, data);
    const deserialize = (data) => _chunkDF4AIGIWcjs.decodeJson.call(void 0, data);
    const bobHub = _chunkSDJIWERFcjs.useRPCHub.call(void 0, {
      post: (data) => channel.port1.postMessage(data),
      on: (data) => channel.port1.on("message", data),
      serialize,
      deserialize
    });
    const bob = bobHub(Bob);
    const alice = _chunkSDJIWERFcjs.useRPC.call(void 0, Alice, {
      // mark bob's `bump` as an event without response
      eventNames: ["bump"],
      post: (data) => channel.port2.postMessage(data),
      on: (data) => channel.port2.on("message", data),
      serialize,
      deserialize
    });
    expect(await bob.hello("Bob")).toEqual("Hello Bob, my name is Alice");
    expect(await alice.hi("Alice")).toEqual("Hi Alice, I am Bob");
    expect(void alice.bump()).toBeUndefined();
    expect(Bob.getCount()).toBe(0);
    await new Promise((resolve) => setTimeout(resolve, 100));
    expect(Bob.getCount()).toBe(1);
    channel.port1.close();
    channel.port2.close();
  });
  it("timeout async", async (done) => {
    const [f1, f2] = _chunkIPYKH5TAcjs.createLocalChannelPair.call(void 0, );
    const rpc1 = _chunkSDJIWERFcjs.useRPC.call(void 0, {
      async echo(v, s = 5) {
        await _chunkQYCE2TUJcjs.sleep.call(void 0, s);
        return `${v}_1`;
      }
    }, {
      post: (data) => {
        f1.postMessage(data);
      },
      on: (data) => f1.on("message", (msg) => {
        void data(msg.data);
      }),
      timeout: 10
    });
    const rpc2 = _chunkSDJIWERFcjs.useRPC.call(void 0, {
      async echo(v, s = 5) {
        await _chunkQYCE2TUJcjs.sleep.call(void 0, s);
        return `${v}_2`;
      }
    }, {
      post: (data) => {
        f2.postMessage(data);
      },
      on: (data) => f2.on("message", (msg) => {
        void data(msg.data);
      }),
      timeout: 10
    });
    const r = await rpc1.echo("abc");
    expect(r).toMatchInlineSnapshot(`"abc_2"`);
    try {
      const r2 = await rpc1.echo("abc", 50);
      expect(false).toBe(true);
    } catch (err) {
      expect(err).toMatchInlineSnapshot(`[Error: rpc timeout on calling "echo"]`);
    }
  });
  it("async", async (done) => {
    function echo(n) {
      return n;
    }
    async function echoAsync(n) {
      return n;
    }
    expect(await echo(1)).toBe(1);
    expect(await echoAsync(2)).toBe(2);
  });
});
//# sourceMappingURL=rpc.spec.cjs.map