import {
  MemStorage
} from "../../chunk-SRT6T6F5.js";
import "../../chunk-R6KULE2F.js";
import "../../chunk-6GHO7LQW.js";

// src/common/storage/memstorage.spec.ts
describe("memStorage", () => {
  it("should store data and read it again", () => {
    const db = new MemStorage();
    db.clear();
    expect(db.allKeys()).toEqual([]);
    db.setItem("a", 1);
    db.setItem("b", { complex: [1, 2, "3"] });
    db.setItem("c", [0, 9, 8]);
    db.setItem("c", "Again!");
    expect(db.allKeys()).toEqual(["a", "b", "c"]);
    expect(db.getItem("a")).toEqual(1);
    expect(db.getItem("b")).toEqual({ complex: [1, 2, "3"] });
    expect(db.getItem("c")).toEqual("Again!");
    expect(db.getItem("d")).toBe(void 0);
    expect(db.getItem("d")).toBe(void 0);
    db.removeItem("a");
    expect(db.getItem("a")).toBe(void 0);
  });
});
//# sourceMappingURL=memstorage.spec.js.map